;; -*- Mode: Scheme -*-

(include "eotya.scm")

(define-predicate stack?)
(define-operation (push! self item))
(define-operation (pop! self))
(define-operation (items self))

(define (make-stack)
  (let ((stack (list)))
    (object
     ((push! self item)
      (set! stack (cons item stack)))
     ((pop!  self)
      (if (null? stack)
	  #f
	  (let ((result (car stack)))
	    (set! stack (cdr stack))
	    result)))
     ((items self)
      stack)
     )))
